import subprocess
import platform
import os

print "--------------------------------------"
print "Welcome to NanoShaper Setup"
print "--------------------------------------"
print "This script will setup NanoShaper executable"
print "At the end check the build results in make_ns.txt."
print "For any help contact sergio.decherchi@iit.it"
print "Before starting assure that you have root privilges,"
print "and, if you are on Mac, of having XCode installed."
print "Moreover wget/curl are needed in Linux/Mac respectively"
print "together with a working Internet connection"
print "--------------------------------------"
print ""

str = raw_input('Do you want to continue? [y/n] ').lower()
if (str!='y'):
	quit()

pwd = os.getcwd()
print "Trying to guess OS ..."

# mac flag
mac = 0
# snowleopard and leopard
mode32 = 0

plat = platform.system()
plat = plat.split('-')
plat = plat[0]
plat = plat.lower()

if (plat == 'darwin'):
	mac = 1
	print "Detected Mac-OS Darwin, installing required packages (boost, gmp, mpfr)"
	print "This script assumes that you have fink software manager installed (it ships with Xcode)\n"
	str = raw_input('Do you want to continue? [y/n] ').lower()
	if (str == 'y'):
		pass
	else:
		quit()
	
	v = platform.mac_ver()[0].split('.')
	
	if (v[0]=='10' and v[1]=='6'):
		print "Detected Snowleopard. For compatibility reasons the build is forced to 32 bits"
		str = raw_input('Do you want to install packets? [y/n] ').lower()
		if (str == 'y'):
			subprocess.call('fink -y install boost1.46.1.cmake',shell=True)
			subprocess.call('fink -y install gmp5',shell=True)
			subprocess.call('fink -y install libmpfr4',shell=True)
			
		mode32 = 1
	
	elif (v[0]=='10' and v[1]=='7'):
		print "Detected Lion."
		print "Please perform packets installation by hand before proceeding"
		str = raw_input('Do you want to continue? [y/n] ').lower()
		if (str == 'y'):
			pass
		else:
			quit()
	
	elif (v[0]=='10' and v[1]=='8'):
		print "Detected Mountain Lion."
		print "Please perform packets installation by hand before proceeding"
		str = raw_input('Do you want to continue? [y/n] ').lower()
		if (str == 'y'):
			pass
		else:
			quit()
	
	elif (v[0]=='10' and v[1]<='5'):
		print "Detected Leopard or previous OS. For compatibility reasons the build is forced to 32 bits"
		print "Please perform packets installation by hand before proceeding"
		mode32 = 1
		str = raw_input('Do you want to continue? [y/n] ').lower()
		if (str == 'y'):
			pass
		else:
			quit()
	
elif (plat == 'windows'):
	print "Please read NanoShaper manual to compile or use precompiled executable"
	quit()
else:
	distro = platform.linux_distribution()[0]
	distro = distro.lower()
	print "Detected Linux os"

	if (('suse' in distro) or ('opensuse' in distro)):
		print "Detected SUSE Linux distribution, installing required packages: boost, gmp, mpfr, cmake"
		print ""
		str = raw_input('Do you want to install packets? [y/n] ').lower()
		if (str=='y'):
			subprocess.call('yast -i boost boost-devel gmp gmp-devel mpfr mpfr-devel cmake',shell=True)
	elif (('ubuntu' in distro) or ('debian' in distro)):
		print "Detected Debian based Linux distribution, installing required packages: boost, gmp, mpfr, cmake, g++" 
		str = raw_input('Do you want to install packets? [y/n] ').lower()
		if (str=='y'):
			subprocess.call('apt-get -y install g++',shell=True)
			subprocess.call('apt-get -y install libboost-thread-dev',shell=True)
			subprocess.call('apt-get -y install libmpfr-dev',shell=True)
			subprocess.call('apt-get -y install cmake',shell=True)
	elif (('red' in distro) or ('hat' in distro) or ('redhat' in distro) or ('centos' in distro) or ('fedora' in distro)):
		print "Detected RedHat based Linux distribution, installing required packages: boost, gmp, mpfr, cmake"
		str = raw_input('Do you want to install packets? [y/n] ').lower()
		if (str=='y'):
			subprocess.call('yum install boost',shell=True)
			subprocess.call('yum install boost-devel',shell=True)
			subprocess.call('yum install gmp',shell=True)
			subprocess.call('yum install gmp-devel',shell=True)
			subprocess.call('yum install mpfr',shell=True)
			subprocess.call('yum install mpfr-devel',shell=True)
			subprocess.call('yum install cmake',shell=True)
	else:
		print "I am not able to retrieve a known distro."
		print "You have to install packets manually; these are:"
		print "boost, gmp, mpfr, cmake. If you find boost-devel, gmp-devel etc.."
		print "please also install them to make header files available."
		print ""
		str = raw_input('Do you want to continue? [y/n] ').lower()
		if (str == 'y'):
			pass
		else:
			quit()
print ""
print "Downloading and extracting CGAL..."
print ""

if (mac==1):
	subprocess.call('curl -C - -O https://gforge.inria.fr/frs/download.php/29125/CGAL-3.9.tar.gz',shell=True)
else:
	subprocess.call('wget https://gforge.inria.fr/frs/download.php/29125/CGAL-3.9.tar.gz',shell=True)
subprocess.call('sync',shell=True)
subprocess.call('tar xvf CGAL-3.9.tar.gz',shell=True)
subprocess.call('sync',shell=True)

print ""
print "Patching CGAL..."
print ""

subprocess.call('rm -f ./CGAL-3.9/include/CGAL/Weighted_point.h',shell=True)
subprocess.call('sync',shell=True)
subprocess.call('cp ./CGALPatch/Weighted_point.h ./CGAL-3.9/include/CGAL/',shell=True)
subprocess.call('sync',shell=True)

print ""
print "Building CGAL..."
print ""

if (mode32==0):
	build_cgal = 'cd CGAL-3.9 \n rm -f CMakeCache.txt \n sync \n cmake . -DWITH_examples=false -DWITH_CGAL_Qt4=false -DWITH_CGAL_Qt3=false -DWITH_CGAL_ImageIO=false > cmake_cgal.txt \n sync \n make clean \n make > make_cgal.txt \n sync'
else:
	# forcing 32 bits mode
	build_cgal = 'cd CGAL-3.9 \n rm -f CMakeCache.txt \n sync \n cmake . -DWITH_examples=false -DWITH_CGAL_Qt4=false -DWITH_CGAL_Qt3=false -DWITH_CGAL_ImageIO=false -DCMAKE_CXX_FLAGS="-arch i386" > cmake_cgal.txt \n sync \n make clean \n make > make_cgal.txt \n sync'
	
subprocess.call(build_cgal,shell=True)

print ""
print "Building NanoShaper..."
print ""

if (mode32==0):
	build_ns = 'cd build \n rm -fr * \n cmake .. -DCGAL_DIR=%s/CGAL-3.9 > cmake_ns.txt \n make clean \n make > make_ns.txt'%(pwd)
else:
	# forcing 32 bits mode
	build_ns = 'cd build \n rm -fr * \n cmake .. -DCGAL_DIR=%s/CGAL-3.9 -DCMAKE_CXX_FLAGS="-arch i386" > cmake_ns.txt \n make clean \n make > make_ns.txt'%(pwd)
	
subprocess.call(build_ns,shell=True)
